SystemOrganization addCategory: #'RecentSubmissions-Core'!
SystemOrganization addCategory: #'RecentSubmissions-MessageWrappers'!
SystemOrganization addCategory: #'RecentSubmissions-UI'!

MorphTreeNodeModel subclass: #MessageListAbstractNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-UI'!

!MessageListAbstractNode commentStamp: '<historical>' prior: 0!
A MessageListAbstractNode is an abstract node model.
Instance Variables
!

!MessageListAbstractNode methodsFor: 'comparing' stamp: 'AlainPlantec 2/13/2011 17:46'!
= anotherNode

	anotherNode species = self species
		ifTrue: [^ self item = anotherNode item]
		ifFalse: [^ false].! !

!MessageListAbstractNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
doubleClick

	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 20:29'!
environment

	self model 
		ifNotNil: [:m| ^m environment].
	self error: 'The model should probably not be nil'! !

!MessageListAbstractNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
getClass

	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
includes: aNode
	
	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
inspectableContents
	
	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
isInspectable

	^self subclassResponsibility
! !

!MessageListAbstractNode methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
isMethod

	^ self item isMethod.! !

!MessageListAbstractNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
originalIndex

	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'action' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
printList: aStream

	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'action' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
removeMe
	
	^self subclassResponsibility! !

MessageListAbstractNode subclass: #MessageListInspectableNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-UI'!

!MessageListInspectableNode methodsFor: 'overrided' stamp: 'VeronicaUquillas 8/31/2011 23:51'!
asString
	^ self item ifNotNil: [self item fullName ] ! !

!MessageListInspectableNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
doubleClick

	self item browse! !

!MessageListInspectableNode methodsFor: 'accessing' stamp: 'VeronicaUquillas 9/3/2011 20:14'!
getClass

	^self item realClass! !

!MessageListInspectableNode methodsFor: 'testing' stamp: ''!
includes: aNode

	^ self = aNode complexContents.! !

!MessageListInspectableNode methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 17:48'!
inspectableContents

	^ OrderedCollection with: self! !

!MessageListInspectableNode methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
isInspectable

	^true! !

!MessageListInspectableNode methodsFor: 'accessing' stamp: ''!
originalIndex

	^self model originalIndex: (self item)! !

!MessageListInspectableNode methodsFor: 'action' stamp: 'VeronicaUquillas 9/3/2011 20:12'!
printList: aStream
	
	aStream nextPutAll: self item fullName! !

MessageListAbstractNode subclass: #MessageListNonInspectableNode
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-UI'!

!MessageListNonInspectableNode methodsFor: 'overrided' stamp: 'AlainPlantec 2/13/2011 20:18'!
asString
	^ self item
		ifNotNil: [self level = 1
				ifTrue: [self model level = 2
						ifTrue: [self item name asString]
						ifFalse: [self model level = 3
								ifTrue: [self item asString]]]
				ifFalse: [self item name asString]] ! !

!MessageListNonInspectableNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
childNodeClassFromItem: anItem

	self level = 1
		ifTrue: [
			self model level = 2
				ifTrue:[^MessageListInspectableNode].
			self model level = 3
				ifTrue:[^self class]]
		ifFalse: [^MessageListInspectableNode]
! !

!MessageListNonInspectableNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2012 04:31'!
childrenItems

	self level = 1
		ifTrue: [
			self model level = 2
				ifTrue:[ ^ self dictionary at: self item ].
			self model level = 3
				ifTrue:[ ^ self dictionary keys sort:[:a :b | a asString < b asString ]]]
		ifFalse: [ ^ self dictionary at: self item ]

! !

!MessageListNonInspectableNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
dictionary

	dictionary ifNil: [
		self parentNode isNil
			ifTrue:  [
				self model level = 2
					ifTrue: [dictionary := self model dictionary].
				self model level = 3
					ifTrue:[dictionary := self model dictionary at: self item]]
			ifFalse: [dictionary := self model dictionary at: (self parentNode item)]].
	^dictionary! !

!MessageListNonInspectableNode methodsFor: 'overrided' stamp: 'StephaneDucasse 10/15/2011 20:59'!
doubleClick

	| class |
	self level = 1
		ifTrue: [
			self model level = 2
				ifTrue:[class := self getClass].
			self model level = 3
				ifTrue:[class := (self childNodeFromItem: (self childrenItems first)) getClass]]
		ifFalse: [
			class := self getClass].
		Smalltalk tools browser
			fullOnClass: class selector: nil
	! !

!MessageListNonInspectableNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
getClass

	self level = 1
		ifTrue: [
			self model level = 2
				ifTrue:[^self item].
			self model level = 3
				ifTrue:[^self error: 'You shouldn''t ask the class of a package']]
		ifFalse: [^self item]! !

!MessageListNonInspectableNode methodsFor: 'testing' stamp: 'AlainPlantec 2/13/2011 19:35'!
includes: aNode 
	^ self = aNode complexContents | (self contents
			detect: [:each | each includes: aNode]
			ifNone: []) notNil ! !

!MessageListNonInspectableNode methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 17:49'!
inspectableContents

	| result |
	result := OrderedCollection new.
	self contents 
		do: [:each | result addAll: each inspectableContents].
	^ result.! !

!MessageListNonInspectableNode methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
isInspectable

	^false! !

!MessageListNonInspectableNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
originalIndex

	| methodReference |
	self level = 1
		ifTrue: [
			self model level = 2
				ifTrue: [methodReference := (self childrenItems first)].
			self model level = 3
				ifTrue: [ methodReference := (self dictionary associations first value first).]]
		ifFalse: [
			methodReference := (self childrenItems first)].
	^self model originalIndex: methodReference
	! !

!MessageListNonInspectableNode methodsFor: 'action' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
printList: aStream

	| tab |
	tab := '- '.
	aStream 
		nextPutAll: self item asString;
		nextPutAll: ' :'.
	self contents do: [:each | 
			aStream nextPutAll: '
'.
			aStream nextPutAll: tab.
			each printList: aStream]
! !

!MessageListNonInspectableNode methodsFor: 'action' stamp: ''!
removeMe

	self contents do: [:each | each removeMe].! !

!ChangeRecord methodsFor: '*RecentSubmissions-Core' stamp: 'BenjaminVanRyseghem 5/6/2011 17:39'!
<= anotherOne

	self stamp ifNil: [ ^ false ].
	anotherOne stamp ifNil: [ ^ true ].
	^ self timeStamp <= anotherOne timeStamp ! !

!ChangeRecord methodsFor: '*RecentSubmissions-Core' stamp: 'BenjaminVanRyseghem 5/6/2011 17:48'!
printOn: aStream

	aStream 
		nextPutAll: self type printString.
	self stamp ifNotNil: [ aStream nextPutAll: self stamp ]! !

!ChangeRecord methodsFor: '*RecentSubmissions-Core' stamp: 'MarcusDenker 4/29/2012 10:33'!
sourceCode
	
	self type= #preamble ifTrue: [ ^ #preamble printString ].
	self type= #doIt ifTrue: [ ^ #preamble printString ].
	self type= #classComment ifTrue: [ self commentClass ifNotNil: [ :comment | ^ comment comment ]].

	self methodClass ifNil: [ ^ '' ].
	^ (self methodClass >> self methodSelector) sourceCode! !

!CompiledMethod methodsFor: '*RecentSubmissions' stamp: ''!
stamp

	^ self timeStamp! !

MorphTreeModel subclass: #MessageListBrowser
	instanceVariableNames: 'model textArea preference wrapper preferenceList sortingList sortingSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-UI'!

!MessageListBrowser commentStamp: 'BenjaminVanRyseghem 8/31/2010 01:43' prior: 0!
MessageListBrowser is the UI for instances of MessageList

Instance Variables:
	messageList	<Object>
	dictionary	<BrowserEnvironment | Dictionary | OpenFileStreamRegistry | RBSmallDictionary | SharedPool class | SmallDictionary | SmalltalkImage | WeakRegistry>
	originalList	<ProtoObject | PseudoContext>
	selectedMorph	<Object>
	treeMorph	<MorphTreeMorph>
	textArea	<CodeMorph | OBPluggableTextMorphWithShout | PluggableShoutMorph | PluggableTextMorphPlus>
	dropList	<ProtoObject | PseudoContext>
	preference	<Object>
	sortingSelector	<ProtoObject | PseudoContext>!

!MessageListBrowser class methodsFor: 'deprecated' stamp: 'StephaneDucasse 11/26/2010 16:58'!
byClassOn: aMessageList

	^self 
		on: aMessageList 
		groupedUsing: aMessageList byClassSelector! !

!MessageListBrowser class methodsFor: 'deprecated' stamp: 'StephaneDucasse 11/26/2010 16:58'!
byDateAscendingOn: aMessageList

	^self 
		on: aMessageList 
		groupedUsing: aMessageList byDateAscendingSelector! !

!MessageListBrowser class methodsFor: 'deprecated' stamp: 'StephaneDucasse 11/26/2010 16:58'!
byDateDescendingOn: aMessageList

	^self 
		on: aMessageList 
		groupedUsing: aMessageList byDateDescendingSelector.! !

!MessageListBrowser class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/29/2010 10:23'!
on: aMessageList
	^self new model: aMessageList
	! !

!MessageListBrowser class methodsFor: 'deprecated' stamp: 'BenjaminVanRyseghem 9/17/2011 16:53'!
on: aMessageList groupedUsing: aSelector
	
	aMessageList perform: aSelector.
	^self new
		model: aMessageList.

	! !

!MessageListBrowser methodsFor: 'items addition' stamp: 'BenjaminVanRyseghem 3/16/2012 01:12'!
addAllItems: aWindow

	| width toolbar btnFont |	
	toolbar := self buildToolbar: aWindow.
	btnFont := StandardFonts buttonFont.
	aWindow
		addMorph: (self treeMorph buildContents; yourself)
		fullFrame: (LayoutFrame
			fractions: (0@0 corner: 1@0.5)
			offsets:(0@0 corner:0@0)).
	aWindow
		addMorph: toolbar
		fullFrame: (LayoutFrame
			fractions: (0@0.5 corner: 1@0.5)
			offsets:(0@0 corner:0@(btnFont height + 14))).
			
	self textArea: self buildTextArea.
	
	aWindow
		addMorph: self textArea
		fullFrame: (LayoutFrame
			fractions: (0@0.5 corner: 1@1)
			offsets:(0@(btnFont height + 14) corner:0@0)).! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
browseButtonAction 

	self browseSelectedMorph! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
browseButtonLabel

	^'Browse'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'AlainPlantec 2/13/2011 15:22'!
browseButtonState 

	^self selectedItem isNil.! !

!MessageListBrowser methodsFor: 'menus' stamp: 'AlainPlantec 2/13/2011 15:30'!
browseSelectedMorph

	self selectedNode ifNotNil: [ :node | node doubleClick].! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
buildButtonBrowse
	
	^(PluggableButtonMorph 
		on: self 
		getState: #browseButtonState 
		action: #browseButtonAction 
		label: #browseButtonLabel)
		hResizing: #spaceFill! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
buildButtonClear
	
	^(PluggableButtonMorph 
		on: self 
		getState: #clearButtonState 
		action: #clearButtonAction 
		label: #clearButtonLabel)
		hResizing: #spaceFill! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
buildButtonRemove
	
	^(PluggableButtonMorph 
		on: self 
		getState: #removeButtonState 
		action: #removeButtonAction 
		label: #removeButtonLabel)
		hResizing: #spaceFill! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/29/2010 11:14'!
buildButtonRevert
	
	^(PluggableButtonMorph 
		on: self 
		getState: #revertButtonState 
		action: #revertButtonAction 
		label: #revertButtonLabel)
		hResizing: #spaceFill! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/20/2012 14:26'!
buildDisplayDropList: aWindow

	^ DropListMorph new
			useSelectionIndex: false;
			wrapSelector: #wrapDropListItem:;
			
			on: self 
			list: #getDisplayList
			selected: #sortingSelector
			changeSelected: #sortingSelector:;
			
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			
			hResizing: #rigid;
			width: 150;
			setBalloonText: self sortingSelectorHelpText;
			yourself! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/20/2012 14:26'!
buildPreferenceDropList: aWindow

	^ DropListMorph new
			useSelectionIndex: false;
			wrapSelector: #wrapPreference:;
			
			on: self 
			list: #getPreferencesList
			selected: #preference
			changeSelected: #preference:;
			
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			
			hResizing: #rigid;
			width: 125;
			yourself! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'sd 3/25/2012 20:49'!
buildTextArea

	| text |
	text := self textMorphClass 
		on: self
		text: #textToDisplay
		accept: #compileMethod:
		readSelection: nil
		menu: #msgPaneMenu:shifted:.
	text 
		visible: false;
		askBeforeDiscardingEdits: true.
	text font: StandardFonts codeFont.
	^ text! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/13/2011 13:36'!
buildToolbar: aWindow
	"create the buttons toolbar"
	
	| toolbar |
	toolbar := aWindow newToolbar: {
		self buildDisplayDropList: aWindow.
		self buildButtonBrowse.
		self buildButtonRevert.
		self buildButtonRemove.
		self buildButtonClear.
		self buildPreferenceDropList: aWindow.}.
	^toolbar hResizing: #shrinkWrap! !

!MessageListBrowser methodsFor: 'droplist-items' stamp: ''!
byClassItem

	^ DropListItem
		named: self byClassLabel
		do: [ self model ifNotNil: [:m | m groupedByClass ]]! !

!MessageListBrowser methodsFor: 'droplist-labels' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
byClassLabel

	^'By Class'! !

!MessageListBrowser methodsFor: 'droplist-items' stamp: ''!
byDateAscendingItem

	^ DropListItem
		named: self byDateAscendingLabel
		do: [ self model ifNotNil: [:m | m groupedByDateAscending ]]! !

!MessageListBrowser methodsFor: 'droplist-labels' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
byDateAscendingLabel

	^'By Date Ascending'! !

!MessageListBrowser methodsFor: 'droplist-items' stamp: ''!
byDateDescendingItem

	^ DropListItem
		named: self byDateDescendingLabel
		do: [ self model ifNotNil: [:m | m groupedByDateDescending ]]! !

!MessageListBrowser methodsFor: 'droplist-labels' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
byDateDescendingLabel

	^'By Date Descending'! !

!MessageListBrowser methodsFor: 'droplist-items' stamp: ''!
byPackageItem

	^ DropListItem
		named: self byPackageLabel
		do: [ self model ifNotNil: [:m | m groupedByPackage ]]! !

!MessageListBrowser methodsFor: 'droplist-labels' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
byPackageLabel

	^'By Package'! !

!MessageListBrowser methodsFor: 'droplist-items' stamp: ''!
byVersionItem

	^ DropListItem
		named: self byVersionLabel
		do: [ self model ifNotNil: [:m | m groupedByVersion ]]! !

!MessageListBrowser methodsFor: 'droplist-labels' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
byVersionLabel

	^'By Version'! !

!MessageListBrowser methodsFor: 'droplist-items' stamp: ''!
byteCodeItem

	^ DropListItem
		named: self byteCodeLabel
		do: [ wrapper := ByteCodeMethodConverter method: wrapper method ]! !

!MessageListBrowser methodsFor: 'droplist-labels' stamp: 'BenjaminVanRyseghem 3/20/2012 14:20'!
byteCodeLabel

	^ 'Byte Code'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
clearButtonAction

	self promptForClear
		ifTrue: [self model clearAll]! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
clearButtonLabel

	^'Clear List'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/11/2011 16:44'!
clearButtonState 

	^self model dictionary isEmpty.! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 3/16/2012 02:50'!
compileMethod: aString

	| method class |
	self preference = self sourceLabel 
		ifFalse: [ 
			textArea flash.
			^ self yourself ].
	self textArea hasUnacceptedEdits: false.
	method := self 
				getMethod: self selectedNode
				ifAbsent: ["use the information from the tree"
					class := self selectedNode getClass.
					nil].
	method ifNotNil: [:m | class := m methodClass].
	class compile: aString.
	self changed: #textToDisplay.! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 14:39'!
dictionary

	| result |
	result := self model dictionary.
	result ifEmpty: [self selection: nil].
	^result! !

!MessageListBrowser methodsFor: 'droplist-items' stamp: ''!
diffItem

	^ DropListItem
		named: self diffLabel
		do: [ wrapper := DiffMethodReferenceConverter methodReference: wrapper method referencesList: self originalList ]! !

!MessageListBrowser methodsFor: 'droplist-labels' stamp: 'BenjaminVanRyseghem 3/20/2012 14:20'!
diffLabel

	^'Diffs'! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 3/16/2012 02:24'!
displayInformationFrom: aMessageListInspectableNode

	^ wrapper getTextFor: aMessageListInspectableNode item! !

!MessageListBrowser methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 11/29/2010 11:16'!
doubleClick

	self selectedNode ifNotNil: [:n | n doubleClick]! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 17:32'!
emptySelection
	
	self selection: nil! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
environment

	^ self model environment! !

!MessageListBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/29/2010 11:45'!
format: aString

	| list size result |
	size := 0.
	list := aString subStrings: String cr.
	list do: [:line || addedCharacter tempSize|
		addedCharacter := ''.
		line first == $- ifTrue: [addedCharacter := '	'].
		tempSize := (addedCharacter, line) size.
		(tempSize > size) ifTrue: [size := tempSize]]! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 3/20/2012 14:55'!
getDisplayList

	sortingList ifNotNil: [ ^ sortingList ].
	^ sortingList := {
		 self byClassItem.
		 self byVersionItem.
		 self byDateAscendingItem.
		 self byDateDescendingItem.
		 self byPackageItem.	}
! !

!MessageListBrowser methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 11/29/2010 11:16'!
getMethod: aMessageListInspectableNode

	| methodReference |
	methodReference := (self getMethodReference: aMessageListInspectableNode) .
	^ methodReference compiledMethod.
	! !

!MessageListBrowser methodsFor: 'tree' stamp: 'VeronicaUquillas 9/3/2011 20:25'!
getMethod: aMessageListInspectableNode ifAbsent: aBlock

	| methodReference |
	methodReference := (self getMethodReference: aMessageListInspectableNode) .
	^ methodReference realClass methodDict
			at: methodReference name
			ifAbsent: aBlock.
	! !

!MessageListBrowser methodsFor: 'tree' stamp: ''!
getMethodReference: aMessageListInspectableNode

	^aMessageListInspectableNode item.! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 3/20/2012 14:35'!
getPreferencesList

	preferenceList ifNotNil: [ ^ preferenceList ].
	^ preferenceList := {	self sourceItem.
		self byteCodeItem.
		self diffItem.
		self versionItem.
		self infoItem. 	}! !

!MessageListBrowser methodsFor: 'display' stamp: ''!
icon 

	^ self model icon! !

!MessageListBrowser methodsFor: 'droplist-items' stamp: ''!
infoItem

	^ DropListItem
		named: self infoLabel
		do: [ wrapper := TimeStampMethodConverter method: wrapper method ]! !

!MessageListBrowser methodsFor: 'droplist-labels' stamp: 'BenjaminVanRyseghem 3/20/2012 14:20'!
infoLabel

	^'Change Date'! !

!MessageListBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/20/2012 14:56'!
initialize

	super initialize.
	wrapper := SourceMethodConverter new.
	
	self preference: self getPreferencesList first.
	self sortingSelector: self getDisplayList first.! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 15:28'!
isComment
	| node |
	node := self selectedNode.
	^(node isInspectable) & (node item = 'Comment'). ! !

!MessageListBrowser methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 11/29/2010 11:16'!
level

	^ self model level.! !

!MessageListBrowser methodsFor: 'menus' stamp: 'AlainPlantec 2/13/2011 17:20'!
menu: menu shifted: b 

	menu
		add: 'Browse' translated
		target: self
		selector: #browseSelectedMorph.
	menu
		add: 'Remove'
		target: self
		selector: #removeSelectedMorph.
	menu
		add: 'Expand All'
		target: self 
		selector: #expandAll.
	menu
		add: 'Collapse All'
		target: self 
		selector: #collapseAll..
	^menu! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 10:22'!
model

	^model! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 17:27'!
model: aModel

	model := aModel.
	model
		when: #changed
		send: #updateView
		to: self.
! !

!MessageListBrowser methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 11/29/2010 11:14'!
msgPaneMenu: aMenu shifted: shifted

	^ aMenu labels: 
'find...(f)
find again (g)
set search string (h)
do again (j)
undo (z)
copy (c)
cut (x)
paste (v)
paste...
do it (d)
print it (p)
inspect it (i)
explore it (I)
debug it
accept (s)
cancel (l)
implementors (m)
methods containing (E)
senders (n)' 
		lines: #(0 3 5 9 14)
		selections: #(find findAgain setSearchString again undo copySelection cut paste pasteRecent doIt printIt inspectIt exploreIt debugIt accept cancel implementorsOfIt methodSourceContainingIt sendersOfIt)! !

!MessageListBrowser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 11/1/2011 07:37'!
open

	| win |
	win := StandardWindow new model: self.
	win title: self model title.
	self addAllItems: win.
	win themeChanged.
	win openInWorld.
	^ win! !

!MessageListBrowser methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
originalIndex: aMethodeReference
	"must respect the original order because the dictionary is automaticaly sorted"

	| tempList |
	tempList := self originalList.
	
	1 to: (tempList size) do:[:i |
			(tempList at: i) == aMethodeReference
				ifTrue: [^i]].
	self error: 'Index not found'.
	^0! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
originalList

	^ self model sortedMethodReferencesList! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
preference

	^ preference! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 3/20/2012 14:26'!
preference: anObject

	preference := anObject.
	anObject value.

	self changed: #textToDisplay.! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
preferenceHelpText

	^'Choose way to show'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
promptForClear
	"Ask if it is OK to remove all the nodes"
	
	^(self confirm: 'Do you really want to clear the list ?' translated)
					
	! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:46'!
promptForRemove: aNode
	"Ask if it is OK to remove the node"
	
	| list |
	
	list := WriteStream on: ''.
	list nextPutAll: 'Are you sure you want to remove :
'.
	aNode printList: list.
	list nextPutAll: ' ?'.
	self format: list contents.

	
	^(self confirm: list contents translated)
					
	! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
removeButtonAction 

	self removeSelectedMorph! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
removeButtonLabel

	^'Remove'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'AlainPlantec 2/13/2011 15:24'!
removeButtonState 

	^self selectedItem isNil.! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'AlainPlantec 2/13/2011 15:28'!
removeSelectedMorph
	self selectedNode ifNotNil: [:n | 
		(self promptForRemove: n)
			ifTrue: [n removeMe]]! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
revertButtonAction 

	(self revertButtonState not and: [self textArea hasUnacceptedEdits not])
		ifTrue: [self compileMethod: self textArea getText asString.]
		ifFalse: [ExampleBuilderMorph new alert: 'The source code must have not been modified']! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
revertButtonLabel

	^'Revert'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'AlainPlantec 2/13/2011 15:29'!
revertButtonState 

	^self selectedNode notNil and: [self selectedNode isInspectable not]
! !

!MessageListBrowser methodsFor: 't - accessing' stamp: 'BenjaminVanRyseghem 3/16/2012 05:08'!
rootItems

	self model useAsASet
		ifTrue: [^ self originalList sort: self sortBlock ]
		ifFalse: [^ (self dictionary keys select: [:each | each isNil not]) sorted: self sortBlock ] "with some test, the class may be nil oO"! !

!MessageListBrowser methodsFor: 't - accessing' stamp: 'BenjaminVanRyseghem 3/16/2012 04:26'!
rootNodeClassFromItem: anItem
	"the class used to build node"
	
	^self model useAsASet 
		ifTrue:[ MessageListInspectableNode ]
		ifFalse: [ MessageListNonInspectableNode ]! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2012 02:43'!
selection: aSelection
	| item |
	super selection: aSelection.
	item :=  self selectedNode.
	item ifNotNil: [ item := item item ].
	wrapper method: item.
	self changed: #textToDisplay.
	self updateTextArea
! !

!MessageListBrowser methodsFor: 'private' stamp: ''!
sortBlock

	self model isSortedByDateAscending
		ifTrue: [ ^  [:a :b | a < b ]].
	self model isSortedByDateDescending
		ifTrue: [ ^  [:a :b | b < a ]].
	^ [:a :b | a asString < b asString ]! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 3/20/2012 14:56'!
sortingSelector

	^ sortingSelector! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 3/20/2012 14:56'!
sortingSelector: anObject

	anObject value.
	sortingSelector := anObject.
	
	self updateView.! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
sortingSelectorHelpText

	^'Set the way to sort items'
! !

!MessageListBrowser methodsFor: 'droplist-items' stamp: ''!
sourceItem

	^ DropListItem
		named: self sourceLabel
		do: [ wrapper := SourceMethodConverter method: wrapper method ]! !

!MessageListBrowser methodsFor: 'droplist-labels' stamp: 'BenjaminVanRyseghem 3/20/2012 14:20'!
sourceLabel

	^'Source'! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
textArea

	^ textArea! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
textArea: anObject

	textArea := anObject! !

!MessageListBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/5/2011 14:04'!
textMorphClass

	^ PluggableTextMorph! !

!MessageListBrowser methodsFor: 'text' stamp: 'AlainPlantec 2/13/2011 15:31'!
textToDisplay
	
	self selectedNode isNil 
		ifFalse: [
			self selectedNode isInspectable 
				ifTrue: [^self displayInformationFrom: self selectedNode]].
	^nil! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'AlainPlantec 10/8/2011 14:21'!
treeMorph
	^ super defaultTreeMorph
			doubleClickSelector: #doubleClick;
			autoDeselection: true;
			getMenuSelector: #menu:shifted:
! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 5/11/2011 16:45'!
updateTextArea

	self textArea ifNil: [^self].
	(self selectedNode isNil)
		ifTrue:  [self textArea visible: false]
		ifFalse: [
			(self selectedNode isInspectable)
				ifTrue: [self textArea visible: true]
				ifFalse: [self textArea hide]]! !

!MessageListBrowser methodsFor: 'display' stamp: 'AlainPlantec 2/13/2011 15:42'!
updateTree
	| prevSelected |
	prevSelected := self selectedItem.
	self changed: #rootNodes.
	prevSelected ifNotNil: [self selectItems: prevSelected]
! !

!MessageListBrowser methodsFor: 'display' stamp: 'AlainPlantec 10/8/2011 14:45'!
updateView
	self model 
		ifNotNil: [:m |
			self changed: #dictionary.
			self changed: #originalList.
			m reSort.
			self updateTree]
! !

!MessageListBrowser methodsFor: 'droplist-items' stamp: ''!
versionItem

	^ DropListItem
		named: self versionLabel
		do: [ wrapper := VersionMethodReferenceConverter methodReference: wrapper method referencesList: self originalList ]! !

!MessageListBrowser methodsFor: 'droplist-labels' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
versionLabel

	^'Version'! !

!MessageListBrowser methodsFor: 'droplist' stamp: ''!
wrapDropListItem: anItem

	^ anItem label! !

!MessageListBrowser methodsFor: 'droplist' stamp: ''!
wrapPreference: anItem

	^ anItem label! !

!RGMethodDefinition methodsFor: '*RecentSubmissions' stamp: 'BenjaminVanRyseghem 3/26/2012 13:23'!
messages

	^ self method messages! !

!RGMethodDefinition methodsFor: '*RecentSubmissions' stamp: ''!
symbolic

	^ self method symbolic! !

Object subclass: #MessageList
	instanceVariableNames: 'methodReferenceList versionsHistoryList useAsASet lastEntry sortingSelector environment dictionary sortedMethodReferencesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-Core'!

!MessageList commentStamp: 'BenjaminVanRyseghem 11/29/2010 11:31' prior: 0!
MessageList is a simple object that holds a set of ordered method definitions.
See MessageList example for an example.

MessageList example

Instance Variables:
	methodReferenceList	<Collection>!

!MessageList class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 11/1/2011 07:43'!
example
	"self example"

	| oldSource newSource t1 t2 t3 ml mlb |
	oldSource := 'example1
	"This is the old version of the method"
	Transcript show: ''This is the old version of the method'' ;cr.'.

	newSource := 'example1
	"This is the new version of the method"
	Transcript show: ''This is the new version of the method'' ;cr.'.

	t1 := RGMethodDefinition
			realClass: MessageList class
			selector: #example.

	MessageList class compile: oldSource classified: 'example'.

	t2 := RGMethodDefinition 
			realClass: MessageList class
			selector: #example1.
		
	"here you can modify MessageList >> initialize to see the difference"
	MessageList class compile: newSource classified: 'example'.
		
	t3 := RGMethodDefinition
			realClass: MessageList class
			selector: #example1.

	ml := MessageList new
			addMethodReference: t1;
			addMethodReference: t2;
			addMethodReference: t3.

	mlb := MessageListBrowser byDateAscendingOn: ml.

	mlb open! !

!MessageList class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 9/17/2011 16:54'!
example1
	"This is the new version of the method"
	Transcript show: 'This is the new version of the method' ;cr.! !

!MessageList class methodsFor: 'setting' stamp: ''!
icon

	^ThemeIcons smallInfoIcon! !

!MessageList class methodsFor: 'toBeRemovedWithStringHolder' stamp: 'StephaneDucasse 9/17/2011 15:34'!
isPseudoSelector: aSelector
	"Answer whether the given selector is a special marker"
	self flag: #toRemoveWhenStringHolderIsGone.
	^ #(Comment Definition Hierarchy) includes: aSelector! !

!MessageList class methodsFor: 'instance creation' stamp: ''!
with: aCollection.

	^self new
		methodReferenceList: aCollection.! !

!MessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 5/6/2011 15:10'!
addFirstVersion

	| systemVersion date association |
	systemVersion := SystemVersion new date: '1 January 1901'.
	date := TimeStamp new.
	association := Association key: systemVersion value: date.
	self versionsHistoryList add: association.! !

!MessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 12/16/2010 15:29'!
addMethodReference: aMethodReference

	self addMethodReferenceSilently: aMethodReference.
	self updateView.! !

!MessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 5/9/2011 14:47'!
addMethodReference: aMethodReference at: index

	self addMethodReferenceSilently: aMethodReference at: index.
	self updateView.! !

!MessageList methodsFor: 'actions' stamp: 'VeronicaUquillas 8/26/2011 10:55'!
addMethodReferenceSilently: aMethodReference

	self useAsASet
		ifTrue: [ self methodReferenceList removeAllSuchThat: [:each | each fullName = aMethodReference fullName]].
	self checkCurrentHighestUpdate: aMethodReference.
	self methodReferenceList add: aMethodReference.
	lastEntry := aMethodReference.! !

!MessageList methodsFor: 'actions' stamp: 'VeronicaUquillas 8/26/2011 10:55'!
addMethodReferenceSilently: aMethodReference at: index

	self useAsASet
		ifTrue: [ self methodReferenceList removeAllSuchThat: [:each | each fullName = aMethodReference fullName]].
	self checkCurrentHighestUpdate: aMethodReference.
	self methodReferenceList at: index put:  aMethodReference.
	lastEntry := aMethodReference.! !

!MessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 11/29/2010 11:28'!
addVersion: anAssociation

	self versionsHistoryList add: anAssociation.
	self updateView! !

!MessageList methodsFor: 'building dictionary' stamp: 'VeronicaUquillas 9/1/2011 14:54'!
buildByClass
	"Return an association where key is a Dictionary and value is the list sorted"
	
	| result tempList |
	result := Dictionary new.
	tempList := self methodReferenceList copy sort: [:m1 :m2 | m2 timeStamp <= m1 timeStamp].
	tempList do: [:each |
		| key value |
		key := each realClass.
		value := each.	
		(result includesKey: key)
			ifFalse: [result at: key put: OrderedCollection new].
		(result at: key) add: value].
	^(Association key: result value: tempList)! !

!MessageList methodsFor: 'building dictionary' stamp: 'VeronicaUquillas 8/31/2011 23:45'!
buildByDate: aBlock
	"Return an association where key is a Dictionary and value is the list sorted"

	| result tempList |
	result := Dictionary new.
	tempList := self methodReferenceList copy sort: aBlock.
	tempList do: [:each |
		| key1 key2 value |
		key1 := each timeStamp asDate.
		key2 := each realClass.
		value := each.		
		(result includesKey: key1)
			ifFalse: [result at: key1 put: Dictionary new].
		((result at: key1) includesKey: key2)
			ifFalse: [(result at: key1) at: key2 put: OrderedCollection new].
		((result at: key1) at: key2) add: value].
	^(Association key: result value: tempList)! !

!MessageList methodsFor: 'building dictionary' stamp: 'VeronicaUquillas 9/1/2011 16:05'!
buildByPackage
	"Return an association where key is a Dictionary and value is the list sorted"

	| result tempList |
	result := Dictionary new.
	tempList := self methodReferenceList copy sort: [:m1 :m2 | m2 timeStamp <= m1 timeStamp].
	tempList do: [:each |
		| class key1 key2 value |
		class := self environment classNamed: each theNonMetaClassName.
		key1 := class category.
		key2 := each actualClass.
		value := each.
			
		(result includesKey: key1)
			ifFalse: [result at: key1 put: Dictionary new].
		((result at: key1) includesKey: key2)
			ifFalse: [(result at: key1) at: key2 put: OrderedCollection new].
		((result at: key1)at: key2) add: value].
	^(Association key: result value: tempList)! !

!MessageList methodsFor: 'building dictionary' stamp: 'BenjaminVanRyseghem 11/29/2010 10:11'!
buildByVersion
	"Return an association where key is a Dictionary and value is the list sorted"
	
	| result tempList |
	result := Dictionary new.
	tempList := self methodReferenceList copy sort: [:m1 :m2 | m2 timeStamp <= m1 timeStamp].
	tempList do: [:each |
		| key value systemVersion |
		systemVersion := self findVersionOf: each.
		key := systemVersion version, ' - ',systemVersion highestUpdate asString..
		value := each.	
		(result includesKey: key)
			ifFalse: [result at: key put: OrderedCollection new].
		(result at: key) add: value].
	^(Association key: result value: tempList)! !

!MessageList methodsFor: 'private' stamp: ''!
byClassSelector

	^ #groupedByClass! !

!MessageList methodsFor: 'private' stamp: ''!
byDateAscendingSelector

	^ #groupedByDateAscending! !

!MessageList methodsFor: 'private' stamp: ''!
byDateDescendingSelector

	^ #groupedByDateDescending! !

!MessageList methodsFor: 'private' stamp: ''!
byPackageSelector

	^ #groupedByPackage! !

!MessageList methodsFor: 'private' stamp: ''!
byVersionSelector

	^ #groupedByVersion! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/29/2010 11:30'!
checkCurrentHighestUpdate: aMethodReference

	| highestUpdate |
	highestUpdate := SystemVersion current highestUpdate.
	(self versionsHistoryList isEmpty or: [highestUpdate > self versionsHistoryList last key highestUpdate])
		ifTrue: [ 
			self addVersion: (Association key: SystemVersion current value: aMethodReference timeStamp)]! !

!MessageList methodsFor: 'actions' stamp: ''!
clearAll

	self methodReferenceList: OrderedCollection new.
	self updateView.! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:26'!
dictionary
	dictionary ifNil: [self groupedByClass].
	^dictionary! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
dictionary: aDictionary

	dictionary := aDictionary! !

!MessageList methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
environment

	^Smalltalk globals! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/10/2011 14:38'!
findIndexOfVersionOf: aMethodReference

	| list timeStamp|
	timeStamp := aMethodReference timeStamp.
	list := self versionsHistoryList.
	list size = 1
		ifTrue: [^1].
	1 to: list size - 1 do: [:i || current next |
		current := list at: i.
		next := list at: (i+1).
		((current value <= timeStamp asDateAndTime) & (next value asDateAndTime> timeStamp asDateAndTime))
			ifTrue: [^i]].
	^list size.! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/29/2010 11:30'!
findVersionOf: aMethodReference

	| index |
	index := self findIndexOfVersionOf: aMethodReference.
	^(self versionsHistoryList at: index) key! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 1/11/2011 14:32'!
groupedByClass
	"update the instance variable"
	
	self groupedByClassSilently.
	self updateView! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 11/29/2010 11:28'!
groupedByClassSilently
	"update the instance variable"
	
	| association |
	association := self buildByClass.
	self dictionary: association key.
	self sortedMethodReferencesList: association value.
	self sortingSelector: self byClassSelector.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 1/11/2011 14:10'!
groupedByDateAscending
	"update the instance variable"
	
	self groupedByDateAscendingSilently.
	self updateView.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 11/29/2010 11:28'!
groupedByDateAscendingSilently
	"update the instance variable"
	
	| association |
	association := self buildByDate: [:m1 :m2 | m1 timeStamp <= m2 timeStamp].
	self dictionary: association key.
	self sortedMethodReferencesList: association value.
	self sortingSelector: self byDateAscendingSelector.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 1/11/2011 14:09'!
groupedByDateDescending
	"update the instance variable"
	
	self groupedByDateDescendingSilently.
	self updateView.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
groupedByDateDescendingSilently
	"update the instance variable"
	
	| association |
	association := self buildByDate: [:m1 :m2 | m2 timeStamp <= m1 timeStamp].
	self dictionary: association key.
	self sortedMethodReferencesList: association value.
	self sortingSelector: self byDateDescendingSelector.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 1/11/2011 14:09'!
groupedByPackage
	"update the instance variable"
	
	self groupedByPackageSilently.
	self updateView! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
groupedByPackageSilently
	"update the instance variable"
	
	| association |
	association := self buildByPackage.
	self dictionary: association key.
	self sortedMethodReferencesList: association value.
	self sortingSelector: self byPackageSelector.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 1/11/2011 14:10'!
groupedByVersion
	"update the instance variable"
	
	self groupedByVersionSilently.
	self updateView! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
groupedByVersionSilently
	"update the instance variable"
	
	| association |
	association := self buildByVersion.
	self dictionary: association key.
	self sortedMethodReferencesList: association value.
	self sortingSelector: self byVersionSelector.! !

!MessageList methodsFor: '*RecentSubmissions-UI' stamp: ''!
icon 

	^ self class icon! !

!MessageList methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 11/29/2010 11:27'!
initialize 
	"Initialization"
	
	super initialize.
	useAsASet := false.
	methodReferenceList := OrderedCollection new.
	self clearAll.
	environment := self environment.
	versionsHistoryList := SortedCollection new sortBlock: [:a :b | a value < b value].
	self addFirstVersion.
	sortedMethodReferencesList := OrderedCollection new.! !

!MessageList methodsFor: 'private' stamp: 'StephaneDucasse 5/15/2011 18:01'!
isEmpty

	^ self methodReferenceList isEmpty! !

!MessageList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
isSortedByClass

	^ self  sortingSelector = self  byClassSelector
	! !

!MessageList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
isSortedByDateAscending

	^self sortingSelector = self byDateAscendingSelector
	! !

!MessageList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
isSortedByDateDescending

	^self sortingSelector = self byDateDescendingSelector
	! !

!MessageList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:30'!
isSortedByPackage

	^self sortingSelector = self byPackageSelector
	! !

!MessageList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:30'!
isSortedByVersion

	^self sortingSelector = self byVersionSelector
	! !

!MessageList methodsFor: 'accessing' stamp: ''!
lastEntry 

	^lastEntry! !

!MessageList methodsFor: 'accessing' stamp: ''!
level
		
	(self level2Selectors includes: (self sortingSelector))
		ifTrue: [^2].
	(self level3Selectors includes: (self sortingSelector))
		ifTrue: [^3].
	self error: 'The selector isn''t classified'! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/20/2011 15:51'!
level2Selectors

	^#( #groupedByClass #groupedByVersion)! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/20/2011 15:51'!
level3Selectors

	^#( #groupedByDateAscending #groupedByDateDescending #groupedByPackage).! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
methodReferenceList

	^ methodReferenceList! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
methodReferenceList: anObject

	methodReferenceList := anObject! !

!MessageList methodsFor: '*RecentSubmissions-UI' stamp: 'BenjaminVanRyseghem 11/1/2011 07:37'!
open
	"opens the system window for recent messages"

	| browser |
	browser := MessageListBrowser on: self.
	browser open.! !

!MessageList methodsFor: 'method version' stamp: 'VeronicaUquillas 9/3/2011 20:26'!
priorVersionOfAMethod: aMethodReference

	| tempList |
	tempList := self methodReferenceList select:[:each | 
		(each className = aMethodReference className) & 
		(each name = aMethodReference name)].
	^ tempList detect: [:each | (self versionOfAMethod: each) = ((self versionOfAMethod: aMethodReference) -1)] ifNone: [aMethodReference].! !

!MessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 11/29/2010 11:28'!
reSort

	^ self perform: (self sortingSelector,'Silently') asSymbol! !

!MessageList methodsFor: 'actions' stamp: ''!
removeMethodReference: aMethodReference

	self methodReferenceList remove: aMethodReference.
	self updateView.! !

!MessageList methodsFor: 'actions' stamp: 'StephaneDucasse 5/15/2011 18:21'!
revertLastMethodSubmission
	"If the most recent method submission was a method change, revert
	that change, and if it was a submission of a brand-new method, 
	remove that method."
	
	"self new revertLastMethodSubmission"
	| changeRecords lastSubmission theClass theSelector |
	self  isEmpty ifTrue: [^ Beeper beep].
	lastSubmission := self  lastEntry.
	theClass := lastSubmission actualClass ifNil: [^ Beeper beep].
	theSelector := lastSubmission selector.
	changeRecords := theClass changeRecordsAt: theSelector.
	changeRecords isEmptyOrNil ifTrue: [^ Beeper beep].
	changeRecords size = 1
		ifTrue:
			["method has no prior version, so reverting in this case means removing"
			theClass removeSelector: theSelector]
		ifFalse:
			[changeRecords second fileIn].! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/3/2011 11:33'!
size

	^ self methodReferenceList size! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
sortedMethodReferencesList

	^sortedMethodReferencesList! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
sortedMethodReferencesList: anObject

	sortedMethodReferencesList := anObject! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
sortingSelector

	sortingSelector ifNil: [^ #groupedByClass].
	^sortingSelector
	! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
sortingSelector: anObject

	sortingSelector := anObject.! !

!MessageList methodsFor: '*RecentSubmissions-UI' stamp: 'BenjaminVanRyseghem 1/11/2011 14:06'!
title
	
	^'Message List'! !

!MessageList methodsFor: '*RecentSubmissions-UI' stamp: 'BenjaminVanRyseghem 11/29/2010 10:56'!
updateView
	
	self changed: #sortingSelector.
	self changed: #sortedMethodReferencesList.
	self changed: #dictionary.
	self triggerEvent: #changed.! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:26'!
useAsASet

	^ useAsASet! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:26'!
useAsASet: anObject

	useAsASet := anObject.
	anObject 
		ifTrue: [	self methodReferenceList: ((self methodReferenceList reversed asSet) asOrderedCollection)].
	self updateView! !

!MessageList methodsFor: 'method version' stamp: 'VeronicaUquillas 9/3/2011 20:26'!
versionOfAMethod: aMethodReference

	| tempList |
	tempList := self methodReferenceList select: [:each | 
		(each className = aMethodReference className) & 
		(each name = aMethodReference name)].
	tempList := tempList sort: [:m1 :m2 | m1 timeStamp < m2 timeStamp].
	^ tempList indexOf: aMethodReference ifAbsent: [0]! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:26'!
versionsHistoryList

	^ versionsHistoryList! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:26'!
versionsHistoryList: anObject

	versionsHistoryList := anObject! !

!MessageList methodsFor: 'private' stamp: 'StephaneDucasse 5/15/2011 18:04'!
zork
	
	^ 34! !

MessageList subclass: #RecentMessageList
	instanceVariableNames: 'maxListSize'
	classVariableNames: 'UniqueInstance'
	poolDictionaries: ''
	category: 'RecentSubmissions-Core'!

RecentMessageList class
	instanceVariableNames: 'settingDropList'!

!RecentMessageList commentStamp: '<historical>' prior: 0!
RecentMessageList record and store all the changes and can show them by doing RecentMessageList openInWorld.!

RecentMessageList class
	instanceVariableNames: 'settingDropList'!

!RecentMessageList class methodsFor: 'cleanup' stamp: 'BenjaminVanRyseghem 3/16/2012 04:35'!
cleanUp

	self allInstancesDo: [:rml| rml initialize].! !

!RecentMessageList class methodsFor: 'instance creation' stamp: ''!
ensureSingletonExistence

	UniqueInstance ifNil: [ UniqueInstance := self basicNew 
														initialize;
														yourself ].! !

!RecentMessageList class methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 3/16/2012 01:05'!
initialize

	Smalltalk addToStartUpList: self.! !

!RecentMessageList class methodsFor: 'instance creation' stamp: ''!
new
	^ self uniqueInstance! !

!RecentMessageList class methodsFor: '*RecentSubmissions-UI' stamp: 'BenjaminVanRyseghem 11/1/2011 07:38'!
open
	
	self flag: #ben. "I do not understand why recentMessageList = the domain object can openInWorld- sd"
	self uniqueInstance open.! !

!RecentMessageList class methodsFor: 'setting' stamp: 'BenjaminVanRyseghem 11/1/2011 07:51'!
recentMessageListMenuOn: aBuilder 
	<worldMenu> 
	
	(aBuilder item: #'Recent Messages')
		action: [self open];
		parent: #Tools;
		help: 'Browse the last messages you''ve submitted';
		icon: self icon;
		order: 1.! !

!RecentMessageList class methodsFor: 'setting' stamp: 'BenjaminVanRyseghem 12/16/2010 15:43'!
recentMessageListSettingOn: aBuilder 
	<systemsettings>

	(aBuilder group: #recentMessageList)
		target: self;
		parent: #codeBrowsing;
		label: 'Recent Messages' translated;
		description: 'Settings related to the recent messages browser' translated;
		with: [
			(aBuilder setting: #maxListSize)
				target: self uniqueInstance;
				label: 'Maximum size of the methods list' translated;
				description: 'If negative or zero, the size will be infinite. Caution : It may slow down your system' translated.
			(aBuilder setting: #useAsASet)
				target: self uniqueInstance;
				label: 'Use as a Set' translated;
				description: 'If true, then the list will act as a Set' translated.]! !

!RecentMessageList class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/16/2012 04:35'!
resetUniqueInstance
	"Reset the singleton of the recentMessageBrowser model, so if you execute it you will lose all the history of the recent messages."
	"self resetUniqueInstance"
	
	self stopNotifications.
	self uniqueInstance triggerEvent: #reset.
	UniqueInstance := nil.
	! !

!RecentMessageList class methodsFor: 'system startup' stamp: ''!
startUp: aBoolean

	self ensureSingletonExistence! !

!RecentMessageList class methodsFor: 'events' stamp: ''!
stopNotifications
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

!RecentMessageList class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/16/2012 01:07'!
uniqueInstance

	self ensureSingletonExistence.
	^UniqueInstance! !

!RecentMessageList methodsFor: 'class event handler' stamp: ''!
aClassHasBeenAdded: anEvent! !

!RecentMessageList methodsFor: 'class event handler' stamp: 'BenjaminVanRyseghem 3/16/2012 01:22'!
aClassHasBeenCommented: anEvent

	anEvent event newStamp notNil
		ifTrue:[self addMethodReference: (self createAClassReference: anEvent)]! !

!RecentMessageList methodsFor: 'class event handler' stamp: ''!
aClassHasBeenModified: anEvent
! !

!RecentMessageList methodsFor: 'class event handler' stamp: ''!
aClassHasBeenRecategorized: anEvent
! !

!RecentMessageList methodsFor: 'class event handler' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
aClassHasBeenRemoved: anEvent

	self removeAClass: anEvent! !

!RecentMessageList methodsFor: 'class event handler' stamp: 'StephaneDucasse 7/26/2011 14:22'!
aClassHasBeenRenamed: anEvent

	| toChangeList |
	toChangeList := self methodReferenceList select: [:each | each className = anEvent oldName asSymbol].
	toChangeList do: [:each | each parentName: anEvent newName asSymbol].
	self updateView.! !

!RecentMessageList methodsFor: 'class event handler' stamp: ''!
aClassHasBeenReorganized: anEvent
! !

!RecentMessageList methodsFor: 'method event handler' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
aMethodHasBeenAdded: aMethodEvent

	self addMethodReference: (self createTheMethodReference: aMethodEvent)
! !

!RecentMessageList methodsFor: 'method event handler' stamp: 'BenjaminVanRyseghem 3/16/2012 04:34'!
aMethodHasBeenModified: aMethodEvent

	self addMethodReference: (self createTheMethodReference: aMethodEvent)
! !

!RecentMessageList methodsFor: 'method event handler' stamp: ''!
aMethodHasBeenRecategorized: aMethodEvent
! !

!RecentMessageList methodsFor: 'method event handler' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
aMethodHasBeenRemoved: aMethodEvent

	self removeAMethod: aMethodEvent
! !

!RecentMessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 12/16/2010 15:53'!
addMethodReference: aMethodReference.

	self addMethodReferenceSilently: aMethodReference.
	self checkSize.
	self updateView! !

!RecentMessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 12/16/2010 15:57'!
checkSize

	| result |
	result := false.
	self maxListSize > 0 "0 means infinite"
		ifTrue: [
			result := (self methodReferenceList size > self maxListSize).
			[self methodReferenceList size > self maxListSize]
				whileTrue: [self methodReferenceList removeFirst]].
	^result! !

!RecentMessageList methodsFor: 'method reference creation' stamp: 'VeronicaUquillas 8/26/2011 10:35'!
createAClassReference: aCommentedEvent

	^RGCommentDefinition realClass: aCommentedEvent item! !

!RecentMessageList methodsFor: 'method reference creation' stamp: 'VeronicaUquillas 8/24/2011 16:18'!
createARemovalMethodReference: aRemovedEvent
	
	| method |
	method := aRemovedEvent item.
	^ RGMethodDefinition
		realClass: method methodClass 
		selector: method selector! !

!RecentMessageList methodsFor: 'method reference creation' stamp: 'BenjaminVanRyseghem 3/16/2012 02:42'!
createTheMethodReference: aModifiedMethodEvent
	
	| method |
	method := aModifiedMethodEvent item.

	^ (RGMethodDefinition
		realClass: method methodClass
		selector: method selector) asHistorical! !

!RecentMessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/16/2010 15:52'!
defaultMaxListSize

	^100! !

!RecentMessageList methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/16/2012 00:59'!
initialize

	super initialize.
	self registerToAnnouncements! !

!RecentMessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/16/2010 15:52'!
maxListSize

	maxListSize ifNil: [maxListSize := self defaultMaxListSize].
	^maxListSize! !

!RecentMessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/16/2010 15:55'!
maxListSize: aNumber

	maxListSize := (aNumber negative 
						ifTrue: [0]
						ifFalse:[aNumber]).
	self checkSize
		ifTrue: [self updateView]! !

!RecentMessageList methodsFor: 'initialization' stamp: ''!
registerToAnnouncements

	SystemAnnouncer announcer weak
		on: ClassAdded send: #aClassHasBeenAdded: to: self;
		on: ClassCommented send: #aClassHasBeenCommented: to: self;
		on: ClassModifiedClassDefinition send: #aClassHasBeenModified: to: self;
		on: ClassRecategorized send: #aClassHasBeenRecategorized: to: self;
		on: ClassRemoved send: #aClassHasBeenRemoved: to: self;
		on: ClassRenamed send: #aClassHasBeenRenamed: to: self;
		on: ClassReorganized send: #aClassHasBeenReorganized: to: self;
		
		on: MethodAdded send: #aMethodHasBeenAdded: to: self;
		on: MethodModified send: #aMethodHasBeenModified: to: self;
		on: MethodRecategorized send: #aMethodHasBeenRecategorized: to: self;
		on: MethodRemoved send: #aMethodHasBeenRemoved: to: self! !

!RecentMessageList methodsFor: 'private' stamp: 'StephaneDucasse 7/26/2011 14:22'!
removeAClass: anEvent
	
	| tempList |
	tempList := self methodReferenceList select:[:each | each className = anEvent item name asSymbol].
	tempList do: [:each | self removeMethodReference: each]! !

!RecentMessageList methodsFor: 'private' stamp: 'VeronicaUquillas 9/1/2011 15:51'!
removeAMethod: aRemovedEvent
	
	| method list |
	method := aRemovedEvent item.
	list := (self methodReferenceList select: [:each |  
						each className = method methodClass name
							and:[ each name = method selector ]]).

	list do: [:each | 
			each fullName: (each className, '>>', each selector, ' (removed)') ].
	self updateView.! !

!RecentMessageList methodsFor: 'private' stamp: 'StephaneDucasse 11/26/2010 17:03'!
stringMethodRemoved

	^'This method have been removed'
	! !

!RecentMessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/11/2011 14:07'!
title

	^'Recent Message List'! !

AbstractMethodConverter subclass: #AbstractMethodReferenceConverter
	instanceVariableNames: 'referencesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-MessageWrappers'!

!AbstractMethodReferenceConverter class methodsFor: 'as yet unclassified' stamp: ''!
methodReference: aMessage referencesList: aListOfReferences

	^ (super 
		method: aMessage)
			referencesList: aListOfReferences;
			yourself! !

!AbstractMethodReferenceConverter methodsFor: 'initialization' stamp: ''!
initialize
	"Initialization code for VersionMessageConverter"

	super initialize.
	referencesList := #()! !

!AbstractMethodReferenceConverter methodsFor: 'private' stamp: ''!
priorVersionOfAMethod: aMethodReference
	| tempList |
	
	tempList := referencesList select:[:each | 
		(each className = aMethodReference className) & 
		(each name = aMethodReference name)].
	^ tempList detect: [:each | (self versionOfAMethod: each) = ((self versionOfAMethod: aMethodReference) -1)] ifNone: [aMethodReference].! !

!AbstractMethodReferenceConverter methodsFor: 'accessing' stamp: ''!
referencesList: aListOfReferences

	referencesList := aListOfReferences! !

!AbstractMethodReferenceConverter methodsFor: 'private' stamp: ''!
versionOfAMethod: aMethodReference
	| tempList |
	
	tempList := referencesList select: [:each | 
		(each className = aMethodReference className) & 
		(each name = aMethodReference name)].
	tempList := tempList sort: [:m1 :m2 | m1 timeStamp < m2 timeStamp].
	^ tempList identityIndexOf: aMethodReference ifAbsent: [0]! !

AbstractMethodReferenceConverter subclass: #DiffMethodReferenceConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-MessageWrappers'!

!DiffMethodReferenceConverter methodsFor: 'private' stamp: ''!
internalGetText	

	^TextDiffBuilder
		 buildDisplayPatchFrom: ((self priorVersionOfAMethod: method) sourceCode) 
		to: (method sourceCode) 
		inClass: (method className)! !

AbstractMethodReferenceConverter subclass: #VersionMethodReferenceConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-MessageWrappers'!

!VersionMethodReferenceConverter methodsFor: 'initialization' stamp: ''!
handleStringSearch

	^ false! !

!VersionMethodReferenceConverter methodsFor: 'private' stamp: ''!
internalGetText
	
	^ String streamContents:[ :s |
			s << 'Version ' << (self versionOfAMethod: method) asString ]! !
RecentMessageList initialize!
